checkRequire("Lua_Jianbaoitem")
checkRequire("Lua_rewardsInfoItem")
Lua_JianBaoWindow = class("Lua_JianBaoWindow",Lua_Window)

function Lua_JianBaoWindow:ctor(p)	
	self:superCall("ctor", self.list)
	self.isModel = true
	self.windowName = "Lua_JianBaoWindow"
	self.skinName = "JianBaoWindow_skin"
	self.showBg = false
	self.showClose = false
	self.rd = DataCenter.JianBaoData
end

function Lua_JianBaoWindow:buildShowItem()
	self:superCall("buildShowItem")
   
	local oldJianbao = DataCenter.OperationalActivitiesData:getActivitiesByType(1021, nil)
	if oldJianbao then self.type =0 end
	local newJianbao = DataCenter.OperationalActivitiesData:getActivitiesByType(1043, nil)
	if newJianbao then self.type =1 end
	
	if not self.type then self.type =0 end
    self.modelID = 0

	DataCenter.JianBaoData:JianbaoInfo(self.type)
	self.jianbaodrage = Lua_DragList.new(self.content,2, Vector4(137, 21, 485, 190))
    self.jianbaodrage:setLocation(0, 0, 0)
    self.jianbaodrage:setListCell(Lua_Jianbaoitem, 97, 97, 5)

    self:addLuaEvent("JIANBAOINFO_UPDATE",self,self.jianbaoUpData)
    self.oneBtn:addClickFuntion(self, self.ononeJianbaoClick)	
    self.automatic:addClickFuntion(self, self.onautomaticJianbaoClick)	
    self.wenhao:addClickFuntion(self,self.ontipsClick)
    self.isAutomatic = true

    if getLanType() == 1 then
    	self.tipsLab:setLocation(-40, -153, 0)
    	self.tipsLab.fontSize = 18
    end
end

function Lua_JianBaoWindow:jianbaoUpData()
	self.oneBtn.label = LanUtil.formateStr(LanUtil.getValue(125007), self.rd.money);
	self.jianbaodrage:setLuaArrayData(self.rd.ordinary_rewards,false)
	self.luckyVal:setPercent(self.rd.lucky_value/self.rd.max_lucky_value)
    self.luckyVal.txt:setEnable(true)
    self.luckyVal.txt.text = (Lua_CommonUtil.getNumberTrans(self.rd.lucky_value) .. "/" .. Lua_CommonUtil.getNumberTrans(self.rd.max_lucky_value))
    if self.rd.lucky_value >= self.rd.max_lucky_value then
    	if not self.jindueffect  then
	    	self.jindueffect = UICreate.createUIEffect(self.content, "/effects/scsEffects/jianbao_jindu", "jianbao_jindu", 192, -102)
				self.jindueffect:SetRenderQueue(self.schedule, 1, 2, false)
		else
			self.jindueffect.mainContent:SetActive(true)
		end
	else
		if self.jindueffect then self.jindueffect.mainContent:SetActive(false) end
	end

    if not self.time then
	    self.time = tonumber(self.rd.time_tick) - tonumber(tostring(GlobalVar.cur_tick))
	    self:onTimeTimer()
	    Lua_CommonUtil.addTimer("etimeStr_Timer",1,self,self.onTimeTimer,nil,-1)
	end

    self.tipsLab.text = LanUtil.formateStr(LanUtil.getValue(125006),tostring(self.rd.add_luck_value)) 

	for k in ipairs(self.rd.special_rewards) do
		if not self.itemImg then
			self.obj = UICreate.createGameObject(self.content, 136 ,177,0)
			self.rewardBg = UICreate.createUIAtlasImage(self.obj,"treasureWindow","treasure_equipmentIcon_bg",0,0,90,90)
			self.rewardBg:setDepth(2)

			self.jianbaodi = UICreate.createUIAtlasImage(self.obj,"jianbaoWindow","jianbao_di",0,0,300,294)
			self.jianbaodi:setDepth(1)
	     
			self.itemImg = Lua_ToolImage.new(self.obj)
			self.itemImg:setDepth(3)
		end

		local reward  = Lua_ToolVo.new(tonumber(self.rd.special_rewards[k].id))
		reward.index = self.rd.special_rewards[k].amount
		reward.count = self.rd.special_rewards[k].bind
		reward.star = self.rd.special_rewards[k].equipment.star
		reward.packType = 999
		self.itemImg.data = reward
		self:roundEffectShow(k)
		if self.modelID ~= self.rd.special_rewards[k].id then
	    	self.modelID = self.rd.special_rewards[k].id
	    	self:modelEff()
		end
    end
end
function Lua_JianBaoWindow:modelEff()
    local data = DataCenter.JianBaoData
    data:modelID(self.modelID)
    if self.modelEffect then
    	self.modelEffect:dispose()
    	self.modelEffect = nil
    end

	self.modelEffect = UICreate.createUIEffect(self.content,nil,nil, 0 , 0)	
	self.modelEffect:setRotEnable(true,-247, -89, 300, 400, 1)
	self.modelEffect:setSacle(data.modelsca[1],data.modelsca[2],data.modelsca[3])
	self.modelEffect:setLocation(data.modelpos[1],data.modelpos[2],data.modelpos[3])
	self.modelEffect:setRot(data.modelros[1],data.modelros[2],data.modelros[3])
	self.modelEffect:SetRenderQueue(self.jianbaodi, 1, 2, false)
	self.modelEffect:setUrl(data.floder.."/"..data.fileName,tostring(data.modelName))
	self.modelEffect:setAction(data.await)

	if data.isLoop then
		Lua_CommonUtil.addTimer("effectRoot", 2, self, self.effectRoot)
	else
		Lua_CommonUtil.removeTimer(self,self.effectRoot)
	end
end

function Lua_JianBaoWindow:effectRoot()
  if not self.modelEffect then return end

  local effectRoot = self.modelEffect.mainContent
  if effectRoot then
    effectRoot:SetActive(false)
    effectRoot:SetActive(true)
  end
end

function Lua_JianBaoWindow:roundEffectShow(index)
	if not self.effect then
		self.effect = UICreate.createUIEffect(self.obj,nil ,nil, 0 , 0)			
		self.effect:setSacle(0.85,0.85,0.85)
		self.effect:SetRenderQueue(self.itemImg.item_bg, 10, 2,false)
		self.effect:setUrl("/effects/scsEffects/jianbao_bigreward","jianbao_bigreward")
		self.effect:setEnable(true)
	end
end
function Lua_JianBaoWindow:ontipsClick()
     Lua_WindowUtil.openWin("Lua_RuleTipWindow",nil,DataCenter.JianBaoData.description)
end
function Lua_JianBaoWindow:onTimeTimer()
	if self.time > 0 then
	   self.time = self.time - 1
       self.timetips.text = LanUtil.formateStr(LanUtil.getValue(125001),tostring(TimeTransform.getInstance():transSeconds1(self.time, true)))
	else
       Lua_CommonUtil.removeTimer(self, self.onTimeTimer)
       self.timetips.text = ""
	end
end

function Lua_JianBaoWindow:onBtnCloseClick()
	self:hide()	
end

function Lua_JianBaoWindow:onJianbaoClick()
	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK)
	local leftNum = bagData:getLeftSize()
	local isAutomatic = true

	if not DataCenter.moneyData:isMoneyEnough(209000003,tonumber(DataCenter.JianBaoData.money),true,true) then
		isAutomatic = false
	end

	if leftNum <= 0 then
		DataCenter.packData:showFullBagTip(Lua_PackData.BAG_PACK)
		isAutomatic = false	
	end
	
    if DataCenter.JianBaoData.isrewards then
    	isAutomatic = false
    end

    if not isAutomatic then
    	Lua_CommonUtil.removeTimer(self,self.onJianbaoClick)
    	self.automatic.label = LanUtil.getValue(125002)
    	self.isAutomatic = true
    	self.oneBtn:addClickFuntion(self, self.ononeJianbaoClick)
    	return
    end

	DataCenter.JianBaoData:getJianbao(self.type)
end
function Lua_JianBaoWindow:ononeJianbaoClick()
	if DataCenter.neverTip:getNeverValue(Lua_NeverTipData.JIANBAO_RELIVE) then
		self:onJianbaoClick()
	else
		local tipData = {}
		tipData.des = LanUtil.formateStr(LanUtil.getValue(125005),tostring(DataCenter.JianBaoData.money))  
		tipData.owner = self
		tipData.type = 1
		tipData.subFun = self.onJianbaoClick   --确定
		tipData.neverTip = Lua_NeverTipData.JIANBAO_RELIVE
		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData)
	end
end
function Lua_JianBaoWindow:onautomaticJianbaoClick()
	if self.isAutomatic then
		local tipData = {}
		tipData.des = LanUtil.getValue(125004)  
		tipData.owner = self
		tipData.type = 1
		tipData.subFun = self.onOutClick   --确定
		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData)
	else
		self.isAutomatic = true
		Lua_CommonUtil.removeTimer(self,self.onJianbaoClick)
		self.automatic.label = LanUtil.getValue(125002)
		--self.btnClose:addClickFuntion(self, self.onBtnCloseClick)		
   		self.oneBtn:addClickFuntion(self, self.ononeJianbaoClick)
	end
end


function Lua_JianBaoWindow:onOutClick()
	self.isAutomatic = false  
	self.automatic.label = LanUtil.getValue(125003)
	self:onJianbaoClick()
	Lua_CommonUtil.addTimer("etimeStr_Timer",0.5,self,self.onJianbaoClick)
	self.oneBtn:removeClickFuntion(self, self.ononeJianbaoClick)	
end

function Lua_JianBaoWindow:dispose()
	self:superCall("dispose")
	Lua_CommonUtil.removeTimer(self, self.onTimeTimer) 
	Lua_CommonUtil.removeTimer(self,self.onJianbaoClick)
	if self.effect then
		self.effect:dispose()
	end
	if self.itemImg then
		self.itemImg:dispose()
		self.itemImg  = nil
	end
	if self.modelEffect then
    	self.modelEffect:dispose()
    	self.modelEffect = nil
    end
    Lua_CommonUtil.removeTimer(self,self.effectRoot)
end
